// aboutwnd.cpp : implementation of the CAbout class    
// display an about box with bitmap graphics in a window
// doug overmyer 7/8/93
//

#include "stdafx.h"
#include "album.h"

#include "dibapi.h" 
#include "aboutwnd.h"    

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

////////////////////////////////  Macros     /////////////////////
// CAbout

IMPLEMENT_DYNCREATE(CAbout, CWnd)

BEGIN_MESSAGE_MAP(CAbout, CWnd)
	//{{AFX_MSG_MAP(CAbout)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_NCDESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////  Construction/Destruction  /////////////
// CAbout construction/destruction   
//uTimerID = id for timer
//uTimerPeriod = time period for timer,    
CAbout::CAbout():m_uTimerID(5000)
{
	CAbout::CAbout(5,5000,0);
}

// "In my beginning is my end"
// setup timer to control destruction
CAbout::CAbout(UINT uTimerID,UINT uTimerPeriod,UINT uBitmapID):m_uTimerID(uTimerID)
{           
	BITMAP   bm;     
	m_pSplash = new CBitmap;
	m_pSplash->LoadBitmap(uBitmapID);
	m_pSplash->GetObject(sizeof(BITMAP),&bm);  
	int cxScreen= ::GetSystemMetrics(SM_CXSCREEN);
	int cyScreen= ::GetSystemMetrics(SM_CYSCREEN);

	CreateEx(0,
		"AfxWnd", 
		"About",
		WS_POPUPWINDOW ,         //no frame, titlebar, etc
		(cxScreen-bm.bmWidth) / 2,
		(cyScreen-bm.bmHeight) / 2,		
		bm.bmWidth+1,bm.bmHeight+1, 
		AfxGetApp()->m_pMainWnd->m_hWnd, 
		0,
		NULL);
	ShowWindow( SW_NORMAL );
	UpdateWindow();
	SetTimer(m_uTimerID,uTimerPeriod,NULL);  // will shut down this window
}

CAbout::~CAbout()
{                
	if (m_uTimerID)           // make sure to release timer
	 	KillTimer(m_uTimerID);  
	delete m_pSplash;
}
 
BOOL CAbout::PreCreateWindow(CREATESTRUCT& cs)
{                           // establish gray background brush
	WNDCLASS wc;
	::GetClassInfo(AfxGetInstanceHandle(),"AfxWnd",&wc);    
	cs.lpszClass = AfxRegisterWndClass(wc.style,
	wc.hCursor,
	(HBRUSH)::GetStockObject(LTGRAY_BRUSH),
	NULL);
 	return CWnd::PreCreateWindow(cs);
}   

////////////////////////////  On Handlers       ////////////////////
void CAbout::OnPaint()
{
	CPaintDC DC(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages    
	CDC   memDC;
	CBitmap * pOldBMP;              
	BITMAP   bm;

	memDC.CreateCompatibleDC(&DC);	
	pOldBMP = memDC.SelectObject(m_pSplash); 
	m_pSplash->GetObject(sizeof(BITMAP),&bm);
	DC.BitBlt(0,0,bm.bmWidth,bm.bmHeight,&memDC,0,0,SRCCOPY);
	memDC.SelectObject(pOldBMP);

} 

void CAbout::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType,cx,cy);
}

void CAbout::OnNcDestroy()
{
	CWnd::OnNcDestroy();
	delete this;	
}

void CAbout::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default    
	KillTimer(m_uTimerID);  
	m_uTimerID = 0;
	CWnd::OnTimer(nIDEvent);  
	PostMessage(WM_CLOSE,0,0);	
}
