// prntdoc.h : interface of the CPrntDoc class
// DOvermyer 7/1/93

#include "dibapi.h"

class CPrntDoc : public CDocument
{
protected: // create from serialization only
	CPrntDoc(); 
	virtual ~CPrntDoc();
	DECLARE_DYNCREATE(CPrntDoc)

	HDIB 				m_hDIB ;
	CPalette* 	m_palDIB;
	CSize 			m_sizeDoc;
	CRect*			m_rcThumb ;       
	CStringList m_fileList;
	SState 			m_State;

// Interface
public:
	HDIB GetHDIB() const
		{ return m_hDIB; }
	CPalette* GetDocPalette() const
		{ return m_palDIB; }
	CSize GetDocSize() const
		{ return m_sizeDoc; } 
	CRect*	   GetThumb()
		{ return m_rcThumb;}  
	CStringList* GetFileList()
		{return &m_fileList;}
	SState* GetStateInfo()
	{return &m_State;}

// Operations
public:
	void InitDIB(const char* dibName);
	void InitDIBData();

// On Handlers
protected:
	virtual BOOL    OnNewDocument();
	virtual BOOL OnOpenDocument(const char* pszPathName); 
	
// Generated message map functions
protected:
	//{{AFX_MSG(CPrntDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()  
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

/////////////////////////////////////////////////////////////////////////////
